/* This file is `NOT' GNU, part of mocp: Magneto Optical disk CoPy utility

   Copyright (C) 1993-95  씎Y(oo) <HGG00736@niftyserve.or.jp>
*/
#include	<stdio.h>
#include	<ctype.h>
#include	<string.h>
#include	<signal.h>
#include	<limits.h>
#include	<errno.h>
#include	<time.h>
#ifdef	__STDC__
#include	<stdlib.h>
#endif
#ifdef	HAVE_UNISTD_H
#include	<unistd.h>
#endif
#ifdef	HUMAN68K
#include	<sys/dos.h>
#include	<sys/iocs.h>
#else
#ifdef	MSDOS
#include	<dos.h>
#endif
#endif
#include "ansidecl.h"
#include "getopt.h"
#include "scsiif.h"
#include "error.h"


static char* copyright = "momocopy-" VERSION "  Copyright (C) 1993-95 oo";


/*
 *	쒲p[^
 */
#define	MAX_RETRY_COUNT	(5)
#define	RDWR_UNIT		(BUFSIZ*8)

#ifndef	min
#define	min(a,b)	((a)<(b)?(a):(b))
#endif	min


/*
 *	IvV(GNU getopt())
 */
int	dstid = -1;
int	force;
int	help;
int	inter;
int	nocheck;
int	srcid = -1;
int	temp;
int	verbose = 1;
int	version;
int	debug;

struct option long_opt[] = {
	{"debug",		no_argument,		NULL,		'D'},
	{"dstid",		required_argument,	NULL,		'd'},
	{"force",		no_argument,		NULL,		'f'},
	{"help",		no_argument,		NULL,		'h'},
	{"interactive",	no_argument,		NULL,		'i'},
	{"nochecking",	no_argument,		NULL,		'n'},
	{"srcid",		required_argument,	NULL,		's'},
	{"tempdir",		required_argument,	NULL,		't'},
	{"quiet",		no_argument,		NULL,		'q'},
	{"version",		no_argument,		NULL,		'V'},
	{"verbose",		no_argument,		NULL,		'v'},
	{0, 0, 0, 0}
};


/*
 *	global variables
 */
int	boardid = -1;
int	availunit = 0;
int	unitno = 0;
int	read_retry = 0;
int	write_retry = 0;
long	bufsiz = 0;
char*	bufptr = NULL;
long	tmpsiz = 0;
char*	tmpdir = NULL;

FILE*	tmpfp = NULL;
FILE*	outfp = stdout;

/*
 *	Ԋ֌W
 */
static clock_t	start = 0;
static clock_t	stop  = 0;
static clock_t	s_read_time = 0;
static clock_t	s_writ_time = 0;
static clock_t	t_read_time = 0;
static clock_t	t_writ_time = 0;
static long	total_size = 0L;
static long	real_size = 0L;


static char*	progname;
static char	cwd[PATH_MAX+1];
static char	tmpname[PATH_MAX+1];
static char	tmppath[PATH_MAX+1];


static clock_t	DEFUN_VOID(diff_clock)
{
	clock_t	now, diff;
	static clock_t	old;

	now = clock();
	diff = now - old;
	old = now;
	return diff;
}


static char*	DEFUN_VOID(readline0)
{
	int	c;
	size_t	i;
	static size_t	bufsiz = 0;
	static char*	buf = NULL;

	if (buf == NULL) {
		bufsiz = 256;
		if ((buf = (char*)malloc(bufsiz)) == NULL) {
			fatal("can\'t allocate readline buffer, sorry");
		}
	}
	for (i = 0; (c = getchar()) != EOF; ) {
		if (c == '\r') {
			continue;
		}
		if (c == '\n') {
			buf[i] = '\0';
			return buf;
		}
		buf[i++] = (char)c;
		if (i >= bufsiz) {
			if ((bufsiz += 256) == 0
			||  (buf = (char*)realloc(buf, bufsiz)) == NULL) {
				fatal("can\'t reallocate readline buffer, sorry");
			}
		}
	}
	return NULL;
}


static	void	DEFUN(sigint, (sig), int sig)
{
	extern VOLATILE void term(int code);

	fprintf(stderr, "\ntrap SIGINT: %s abort\n", progname);
	term(2);
}


void	DEFUN_VOID(init)
{
	signal(SIGINT, sigint);
	setvbuf(outfp, NULL, _IONBF, 0);
	if (getcwd(cwd, sizeof cwd) == NULL) {
		fatal("can\'t get current working directory");
	}
}


static void	DEFUN_VOID(disptime)
{
	clock_t	total_time;
	clock_t	io_time;

	total_time = stop - start;
	io_time    = s_read_time + s_writ_time + t_read_time + t_writ_time;

	fputc('\n', outfp);
	if (read_retry || write_retry) {
	fprintf(outfp, "scsi retry: read=%d, write=%d\n", read_retry, write_retry);
	}
	fprintf(outfp, "scsi_read :%4ld.%02ld sec(%2ld%%), %4ld Kbytes/sec\n",
			s_read_time/CLOCKS_PER_SEC, s_read_time%CLOCKS_PER_SEC,
			(s_read_time*100)/total_time,
			(total_size/(s_read_time/CLOCKS_PER_SEC)+512)/1024);
	fprintf(outfp, "scsi_write:%4ld.%02ld sec(%2ld%%), %4ld Kbytes/sec\n",
			s_writ_time/CLOCKS_PER_SEC, s_writ_time%CLOCKS_PER_SEC,
			(s_writ_time*100)/total_time,
			(total_size/(s_writ_time/CLOCKS_PER_SEC)+512)/1024);
	if (temp) {
	fprintf(outfp, "temp_read :%4ld.%02ld sec(%2ld%%), %4ld Kbytes/sec\n",
			t_read_time/CLOCKS_PER_SEC, t_read_time%CLOCKS_PER_SEC,
			(t_read_time*100)/total_time,
			(real_size/(t_read_time/CLOCKS_PER_SEC)+512)/1024);
	fprintf(outfp, "temp_write:%4ld.%02ld sec(%2ld%%), %4ld Kbytes/sec\n",
			t_writ_time/CLOCKS_PER_SEC, t_writ_time%CLOCKS_PER_SEC,
			(t_writ_time*100)/total_time,
			(real_size/(t_writ_time/CLOCKS_PER_SEC)+512)/1024);
	}
	fprintf(outfp, "file  i/o : %2ld min %2ld.%02ld sec(%2ld%%)\n",
			(io_time/CLOCKS_PER_SEC)/60, (io_time/CLOCKS_PER_SEC)%60,
			io_time%CLOCKS_PER_SEC, (io_time*100)/total_time);
	fprintf(outfp, "total time: %2ld min %2ld.%02ld sec\n",
			(total_time/CLOCKS_PER_SEC)/60, (total_time/CLOCKS_PER_SEC)%60,
			total_time%CLOCKS_PER_SEC);
}


VOLATILE void	DEFUN(term, (code), int code)
{
	if (temp && tmpfp) {
		fclose(tmpfp);
#ifndef	DEBUG
		remove(tmpname);
#endif
	}
	if (scsiif_logfp) {
		fclose(scsiif_logfp);
	}
	if (bufsiz && bufptr) {
		free(bufptr);
	}
	ck_scsi_ejectcntl(srcid, SCSI_EJECT_ENABLE);
	if (dstid != srcid) {
		ck_scsi_ejectcntl(dstid, SCSI_EJECT_ENABLE);
	}
	if (code == 0) {
		scsi_eject(dstid);
		stop = clock();
		if (verbose) disptime();
		fprintf(stderr, "\n%s: normal termination, see you again.\n\n", progname);
	}
	chdrive(toupper(cwd[0])-'A'+1);
	chdir(cwd);
	exit(code);
}


/*
 * print help and die!
 */
static void	DEFUN_VOID(usage)
{
	fprintf(stderr,
	"usage: %s [-DfhinqV] [-s srcid] [-d dstid] [-t tempdir]\n"
	"option -D --debug        print debug message\n"
	"       -f --force        force copy mode\n"
	"       -h --help         print this message and die\n"
	"       -i --interactive  interactive mode\n"
	"       -n --nochecking   no checking\n"
	"       -q --quiet        quiet mode\n"
	"       -V --version      print version\n"
	"       -s --srcid        specify source scsi id\n"
	"       -d --dstid        specify destination scsi id\n"
	"       -t --tempdir      specify temporary directory\n",
	progname);
	term(-1);
}


static char*	DEFUN(input, (prompt), CONST char* prompt)
{
	int	len;
	char*	p;

	fprintf(outfp, "%s\? ", prompt);
	for (p = readline0(); isspace(*p); p++) ;
	len = strlen(p)-1;
	if (*(p+len) == '\n') *(p+len--) = '\0';
	if (*(p+len) == '\r') *(p+len--) = '\0';
	return p;
}


static int	DEFUN(input_ok, (str), CONST char* str)
{
	char*	p;

	if (str) fprintf(outfp, "%s ", str);
	p = input("ok(Y/n/q)");
	switch (tolower(*p)) {
	case '\0':
	case '\n':
	case 'y':	return 1;
	case 'q':	term(1);
	}
	return 0;
}


static int	DEFUN(input_yn, (str), CONST char* str)
{
	char*	p;

	if (str) fprintf(outfp, "%s ", str);
	p = input("(Y/n)");
	switch (tolower(*p)) {
	case '\0':
	case '\n':
	case 'y':	return 1;
	}
	return 0;
}


static void	DEFUN_VOID(check_availunit)
{
	int	i, id, sts;
	char	buf[36];
	inquiry_s* inqp;

	unitno = 0;
	inqp = (inquiry_s*)buf;
	if (verbose) fputc('\n', outfp);
	for (id = 0; id < 8; id++) {
		if ((sts = ck_scsi_testunit(id)) == -1 && id != boardid) continue;
		if ((sts & SCSI_STS_CHKCOND) != 0) {
			sts = ck_scsi_testunit(id);
		}
		if (verbose) {
			if (id == boardid) {
				fprintf(outfp, "  id=%d, %sternal", id, (scsi_boardtype()?"ex":"in"));
			}
			else {
				fprintf(outfp, "  id=%d, sts=%s", id, scsi_stslist(sts));
				if (sts & 2) fprintf(outfp, "(%s)", scsi_errlist(sts>>8));
			}
		}
		if (scsi_inquiry(id, inqp, sizeof buf) == 0) {
			if (verbose) {
				if ((buf[4] += 5) > sizeof buf) {
					buf[4] = sizeof buf;
				}
				fputc(':', outfp);
				for (i = 8; i < buf[4]; i++) {
					if (isprint(buf[i])) fputc(buf[i], outfp);
				}
			}
			if (nocheck) {
					availunit |= 1<<id;
					unitno++;
			}
			else if (buf[1]&0x80) {
				switch (buf[0]&0xff) {
				case 0x00:	/* direct access device */
				case 0x07:	/* MO */
				case 0x84:	/* ?? */
					availunit |= 1<<id;
					unitno++;
					if (verbose) fprintf(outfp, " MO");
					break;
				case 0x01:	/* MT */
					if (verbose) fprintf(outfp, " MT");
					break;
				default:
					if (verbose) fprintf(outfp, " other device");
					break;
				}
			}
		}
		if (verbose) fputc('\n', outfp);
	}
	if (unitno == 0) {
		fatal((nocheck ? "can\'t find scsi device, sorry"
		               : "can\'t find removable media, sorry"));
	}
}


static void	DEFUN_VOID(set_singledrive)
{
	int	id;

	for (id = 0; id < 8; id++) {
		if (availunit&(1<<id)) break;
	}
	dstid = srcid = id;
}


static void	DEFUN_VOID(set_doubledrive)
{
	int	id;

	dstid = srcid = -1;
	for (id = 0; id < 8; id++) {
		if (availunit&(1<<id)) {
			if (srcid == -1) {
				srcid = id;
			}
			else if (dstid == -1) {
				dstid = id;
				break;
			}
		}
	}
}


static int	DEFUN_VOID(condition_ok)
{
	int	drive;
#ifdef	MSDOS
	struct diskfree_t	df;
#else
	struct _freeinf	buf;
#endif

	if ((bufsiz = (chkml()/RDWR_UNIT)*RDWR_UNIT) == 0) {
		fatal("illegal buffer size %06x", chkml());
	}
	fprintf(outfp, "\n"
		"     source scsi unit id=%d\n"
		"destination scsi unit id=%d\n"
		"             buffer size=%6ld Kbytes\n", 
		srcid, dstid, bufsiz/1024L);
	if (temp) {
		if (isalpha(*tmpdir) && *(tmpdir+1) == ':') {
			drive = toupper(*tmpdir)-'A'+1;
		}
		else {
			drive = getdrive();
		}
		if (chdrive(drive)
		||  chdir(tmpdir)) {
			fatal("can\'t change directory to %s", tmpdir);
		}
		drive = getdrive();		/* for mount, etc. */
#ifdef	MSDOS
		_dos_getdiskfree(drive, &df);
		tmpsiz = (((long)df.aval_clusters*(long)df.sectors_per_cluster*(long)df.bytes_per_sector)
					/bufsiz)*bufsiz;
#else
		tmpsiz = (_dos_dskfre(drive, &buf)/bufsiz)*bufsiz;
#endif
		if (tmpsiz < bufsiz) {
			temp = 0;
		}
		else {
			fprintf(outfp,
				"     temporary directory=%s\n"
				"     temporary file size=%6ld Kbytes\n",
				tmpdir, tmpsiz/1024);
		}
	}
	if (input_ok(NULL)) {
		return 1;
	}
	srcid = dstid = -1;
	temp = 0;
	return 0;
}


static void	DEFUN_VOID(set_interactive)
{
	char*	p;

	do {
		if (unitno == 1) {
			set_singledrive();
		}
		else {
			if (srcid == -1) {
				do {
					p = input("source scsi unit id(0-7)");
				} while (sscanf(p, "%d", &srcid) != 1 || (srcid&~7) || !(availunit&(1<<srcid)));
			}
			if (dstid == -1) {
				do {
					p = input("destination scsi unit id(0-7)");
				} while (sscanf(p, "%d", &dstid) != 1 || (dstid&~7) || !(availunit&(1<<dstid)));
			}
		}
		if (temp == 0 && nocheck == 0 && srcid == dstid) {
			if (input_yn("use temporary file")) {
				temp = 1;
				tmpdir = strcpy(tmppath, input("directory of temporary file"));
			}
		}
	} while (!condition_ok());
}


static void	DEFUN_VOID(set_automatic)
{
	if (unitno == 1) {
		set_singledrive();
	}
	else {
		set_doubledrive();
	}
	if (!condition_ok()) {
		set_interactive();
	}
}


static long	DEFUN(check_capacity, (id, str, capp, typep, extmodep),
		int id AND char* str AND capacity_s* capp AND int* typep AND int* extmodep)
{
	int	i, sts;
	char*	buf;
	long	blknum, blksiz, capacity;

	do {
		fprintf(outfp, "\ninsert %s disk", str);
		input("");
		for (i = 0; i < MAX_RETRY_COUNT; i++) {
			if ((sts = ck_scsi_testunit(id)) == 0) break;
		}
	} while (sts);
	if (verbose) fprintf(outfp, "  checking %s disk capacity...", str);
	for (i = 0; i < MAX_RETRY_COUNT; i++) {
		if ((sts = ck_scsi_capacity(id, capp)) == 0) break;
		if (verbose) fprintf(outfp, "%2d ", i);
	}
	if (sts) {
		fatal("can\'t read %s medium capacity, sorry", str);
	}
	blknum = *(long*)&capp->block[0];
	blksiz = *(long*)&capp->blksiz[0];
	capacity = (blknum+1) * blksiz;
	switch (blksiz) {
	case 0x100L:	*typep = 0;	break;
	case 0x200L:	*typep = 1;	break;
	case 0x400L:	*typep = 2;	break;
	default:
		fatal("can\'t handle block size=%ld", blksiz);
		break;
	}
	if (verbose) {
		fprintf(outfp, "\n\t  block number=%6ld blocks\n", blknum+1);
		fprintf(outfp,   "\t    block size=%6ld bytes\n", blksiz);
		fprintf(outfp,   "\ttotal capacity=%6ld Kbytes\n", capacity/1024L);
	}
	if ((buf = (char*)malloc(blksiz)) == NULL) {
		fatal("can't allocate buffer");
	}
	scsi_setextmode(1);
	*extmodep = (scsi_read(id, buf, *typep, 0L, 1) ? 0 : 1);
	free(buf);
	if (verbose) {
		if (*extmodep) fprintf(outfp, "\tuse extended scsi_read/write\n");
		fprintf(outfp,   "  done\n");
	}
	return capacity;
}


static void	DEFUN_VOID(dummy)
{
	;	/* DUMMY PROCEDURE */
}


static void	DEFUN(check_ready, (id), int id)
{
	int	i;

	while (ck_scsi_testunit(id) != 0) {
		for (i = 1000; i > 0; i--) {
			dummy();
		}
		_dos_keysns();
	}
}


static void	DEFUN(mocp_readsub, (id, buf, type, pos, siz),
		int id AND PTR buf AND int type AND long pos AND long siz)
{
	int	i, cnt, num, retry;
	long	size;
	char*	p;

	if (verbose) fputc(' ', outfp);
	if (temp) {
		fseek(tmpfp, 0L, SEEK_SET);
		cnt = (siz+(bufsiz-1))/bufsiz - 1;
	}
	else {
		cnt = 1;
	}

	for (i = 0; i < cnt; i++) {
		p = buf;
		size = min(siz, bufsiz);
		num = size/(0x100L<<type);
		diff_clock();
		for (retry = MAX_RETRY_COUNT; scsi_read(id, buf, type, pos, num) == -1; retry--) {
			if (retry <= 0) {
				if (debug) {
					fprintf(stderr, "\n\tscsi_read(%d, %06lx, %d, %ld, %d)\n", id, buf, type, pos, num);
				}
				fatal("scsi read");
			}
		}
		s_read_time += diff_clock();
		read_retry += MAX_RETRY_COUNT - retry;
		if (verbose) fputc('R', outfp);
		if (temp) {
			diff_clock();
#if USE_DOSRDWR
			if (_dos_write(fileno(tmpfp), p, size) != size) {
				if (debug) {
					fprintf(stderr, "\n\t_dos_write(%d, %06lx, %ld)\n", fileno(tmpfp), p, bufsiz);
				}
				fatal("write to temporary");
			}
			if (verbose) fputc('w', outfp);
#else
			while (size > 0) {
				if (fwrite(p, min(size, RDWR_UNIT), 1, tmpfp) != 1) {
					if (debug) {
						fprintf(stderr, "\n\tfwrite(%06lx, %d, 1, tmpfp)\n", p, min(size, RDWR_UNIT));
					}
					fatal("write to temporary");
				}
				if (verbose) fputc('w', outfp);
				p += RDWR_UNIT;
				size -= RDWR_UNIT;
			}
#endif
			t_writ_time += diff_clock();
		}
		siz -= bufsiz;
		pos += num;
	}
	if (temp && siz > 0) {
		size = min(siz, bufsiz);
		num = size/(0x100L<<type);
		diff_clock();
		for (retry = MAX_RETRY_COUNT; scsi_read(id, buf, type, pos, num) == -1; retry--) {
			if (retry <= 0) {
				if (debug) {
					fprintf(stderr, "\n\tscsi_read(%d, %06lx, %d, %ld, %d)\n", id, buf, type, pos, num);
				}
				fatal("scsi read");
			}
		}
		s_read_time += diff_clock();
		read_retry += MAX_RETRY_COUNT - retry;
		if (verbose) fputc('R', outfp);
	}

	if (verbose) fputc(' ', outfp);
}


static void DEFUN(mocp_writesub, (id, buf, type, pos, siz),
		int id AND PTR buf AND int type AND long pos AND long siz)
{
	int i, cnt, num, retry;
	long	size;
	char*	p;

	if (verbose) fputc(' ', outfp);
	if (temp) {
		cnt = (siz+(bufsiz-1))/bufsiz - 1;
		size = min(siz - bufsiz*cnt, bufsiz);
		num = bufsiz/(0x100L<<type);
		diff_clock();
		for (retry = MAX_RETRY_COUNT; scsi_write(id, buf, type, pos + num*cnt, size/(0x100L<<type)) == -1; retry--) {
			if (retry <= 0) {
				if (debug) {
					fprintf(stderr, "\n\tscsi_write(%d, %06lx, %d, %ld, %d)\n", id, buf, type, pos, num);
				}
				fatal("scsi write");
			}
		}
		s_writ_time += diff_clock();
		write_retry += MAX_RETRY_COUNT - retry;
		if (verbose) fputc('W', outfp);
		siz -= size;

		fseek(tmpfp, 0L, SEEK_SET);
		real_size += siz;
	}
	else {
		cnt = 1;
	}

	for (i = 0; i < cnt; i++) {
		p = buf;
		size = min(siz, bufsiz);
		num = size/(0x100L<<type);
		if (temp) {
			diff_clock();
#ifdef	USE_DOSRDWR
			if (_dos_read(fileno(tmpfp), p, size) != size) {
				if (debug) {
					fprintf(stderr, "\n\t_dos_read(%d, %06lx, %ld)\n", fileno(tmpfp), p, bufsiz);
				}
				fatal("read from temporary");
			}
			if (verbose) fputc('r', outfp);
#else
			while (size > 0) {
				if (fread(p, min(size, RDWR_UNIT), 1, tmpfp) != 1) {
					if (debug) {
						fprintf(stderr, "\n\tfread(%06lx, %d, 1, tmpfp)\n", p, min(size, RDWR_UNIT));
					}
					fatal("read from temporary");
				}
				if (verbose) fputc('r', outfp);
				p += RDWR_UNIT;
				size -= RDWR_UNIT;
			}
#endif
			t_read_time += diff_clock();
		}
		diff_clock();
		for (retry = MAX_RETRY_COUNT; scsi_write(id, buf, type, pos, num) == -1; retry--) {
			if (retry <= 0) {
				if (debug) {
					fprintf(stderr, "\n\tscsi_write(%d, %06lx, %d, %ld, %d)\n", id, buf, type, pos, num);
				}
				fatal("scsi write");
			}
		}
		s_writ_time += diff_clock();
		write_retry += MAX_RETRY_COUNT - retry;
		if (verbose) fputc('W', outfp);
		siz -= bufsiz;
		pos += num;
	}

	if (verbose) fputc(' ', outfp);
}


static void	DEFUN_VOID(mocp)
{
	int	i, ntimes, srctype, dsttype, srcext, dstext;
	long	unit, srcsiz, dstsiz, srcpos, dstpos;
	capacity_s	srccap, dstcap;

	errno = 0;	/* re_initialize */
	srcsiz = check_capacity(srcid, "source", &srccap, &srctype, &srcext);
	if (ck_scsi_wrtprotect(srcid) == 0) {
		if (nocheck == 0) {
			fprintf(outfp, "set write protect of source disk\n");
		}
		scsi_eject(srcid);
	}
	else if (srcid == dstid) {
		scsi_eject(srcid);
	}

	dstsiz = check_capacity(dstid, "destination", &dstcap, &dsttype, &dstext);

	if (srcsiz > dstsiz) {
		if (force && input_ok("source medium too large, force copy") != 0) {
			srcsiz = dstsiz;
		}
		else {
			scsi_eject(dstid);
			fatal("source medium too large, sorry");
		}
	}
	if (srctype != dsttype) {
		if (force == 0 || input_ok("block size is different, force copy") == 0) {
			scsi_eject(dstid);
			fatal("block size is different, sorry");
		}
	}

	if (nocheck == 0 && ck_scsi_wrtprotect(dstid)) {
		fprintf(outfp, "unset write protect of destination disk\n");
		if (srcid != dstid) {
			scsi_eject(dstid);
		}
	}

	unit = (temp ? tmpsiz + bufsiz : bufsiz);
	srcpos = dstpos = 0L;
	ntimes = (srcsiz+(unit-1))/unit;

	if (srcid != dstid) {
		ck_scsi_ejectcntl(srcid, SCSI_EJECT_DISABLE);
		ck_scsi_ejectcntl(dstid, SCSI_EJECT_DISABLE);
	}

	total_size = srcsiz;
	fputc('\n', outfp);

	for (i = 0; i < ntimes; i++) {
		check_ready(srcid);
		while (nocheck == 0 && ck_scsi_wrtprotect(srcid) == 0) {
			scsi_eject(srcid);
			fprintf(outfp, "insert source disk\n");
			check_ready(srcid);
		}
		ck_scsi_ejectcntl(srcid, SCSI_EJECT_DISABLE);

		scsi_setextmode(srcext);
		if (verbose) fprintf(outfp, "  %3d/%3d reading...", i+1, ntimes);
		mocp_readsub(srcid, bufptr, srctype, srcpos, (srcsiz > unit ? unit : srcsiz));
		srcpos += unit/(0x100L<<srctype);
		if (verbose) fprintf(outfp, "done\n");

		check_ready(dstid);
		while (ck_scsi_wrtprotect(dstid)) {
			scsi_eject(dstid);
			fprintf(outfp, "insert destination disk\n");
			check_ready(dstid);
		}
		ck_scsi_ejectcntl(dstid, SCSI_EJECT_DISABLE);

		scsi_setextmode(dstext);
		if (verbose) fprintf(outfp, "  %3d/%3d writing...", i+1, ntimes);
		mocp_writesub(dstid, bufptr, dsttype, dstpos, (srcsiz > unit ? unit : srcsiz));
		dstpos = srcpos;
		if (verbose) fprintf(outfp, "done\n\n");

		if ((srcsiz -= unit) <= 0) break;
	}
}


void	DEFUN(main, (argc, argv), int argc AND char** argv)
{
	int c, count;

	start = clock();
	progname = set_progname(argv[0]);
	setvbuf(stdin, NULL, _IONBF, 1);
	init();
#ifdef	HUMAN68K
	if (!scsi_available()) {
		fatal("scsi driver is not available", NULL);
	}
	boardid = scsi_boardid();
#endif

	while ((c = getopt_long(argc, argv, "Dd:fhinqs:t:Vv", long_opt, &count)) != EOF) {
		switch (c) {
		case 0:
			*long_opt[count].flag = 1;
			break;
		case 'D':
			scsiif_debug =
			debug = 1;
			if ((scsiif_logfp = fopen("momocopy.dbg", "wb")) == NULL) {
				fatal("cannot open debug file");
			}
			break;
		case 'd':
			if (sscanf(optarg, "%d", &dstid) != 1
			&&  sscanf(optarg, "=%d", &dstid) != 1) dstid = -1;
			if (dstid & ~7) {
				fatal("illegal scsi id %s", optarg);
			}
			break;
		case 'f':
			force = 1;
			break;
		case 'h':
			help = 1;
			break;
		case 'i':
			inter = 1;
			break;
		case 'n':
			nocheck = 1;
			break;
		case 's':
			if (sscanf(optarg, "%d", &srcid) != 1
			&&  sscanf(optarg, "=%d", &srcid) != 1) srcid = -1;
			if (srcid & ~7) {
				fatal("illegal scsi id %s", optarg);
			}
			break;
		case 't':
			temp = 1;
			tmpdir = (*optarg == '=' ? ++optarg : optarg);
			break;
		case 'q':
			verbose = 0;
			break;
		case 'V':
			version = 1;
			break;
		case 'v':
			verbose = 1;
			break;
		case '?':	/* unkown option */
		default:
			help = 1;
			break;
		}
	}

	if (argc != optind) {
		help = 1;
	}
	if (version) fprintf(stderr, "%s\n", copyright);
	if (help)	 usage();

	fprintf(outfp, (nocheck ? "checking scsi unit..."
	                        : "checking removable scsi unit..."));
	check_availunit();
	fprintf(outfp, "done\n");

	if (nocheck) {
		temp = 0;
		set_interactive();
	}
	else if (inter
	     || (srcid != -1 && (availunit&(1<<srcid)) != 0)
	     || (dstid != -1 && (availunit&(1<<dstid)) != 0)) {
		set_interactive();
	}
	else {
		set_automatic();
	}
	if (srcid != -1 && (availunit&(1<<srcid)) == 0) {
		fatal((nocheck ? "source is not scsi device"
		               : "source scsi unit is not removable medium"));
	}
	if (dstid != -1 && (availunit&(1<<dstid)) == 0) {
		fatal((nocheck ? "destination is not scsi device"
		               : "destination scsi unit is not removable medium"));
	}
	if ((bufptr = malloc(bufsiz)) == NULL) {
		fatal("can\'t allocate main buffer, sorry", NULL);
	}
	if (temp) {
#ifdef	HAVE_TEMPNAM
		char* p;

		if ((p = tempnam(tmpdir, "mocp")) == NULL) {
			fatal("can't make temporary filename");
		}
		strcpy(tmpname, p);
		free(p);
#else
		int	len, slash;
		char* p;

		slash = ERROR_SLASH;
#ifdef	HUMAN68K
		if ((p = getenv("SLASH")) != NULL) {
			slash = *p;
		}
#endif
		strcpy(tmpname, tmpdir);
		len = strlen(tmpname);
		if (isalpha(tmpname[0]) && len == 2 && tmpname[len-1] == ':') {
			tmpname[len++] = '.';
			tmpname[len] = '\0';
		}
		if (tmpname[len-1] != slash && tmpname[len-1] != ERROR_SLASH) {
			tmpname[len++] = slash;
			tmpname[len] = '\0';
		}
		sprintf(tmpname+len, "mocp%04x", getpid()&0x7fff);
#endif	/*HAVE_TEMPNAM*/
		if ((tmpfp = fopen(tmpname, "w+b")) == NULL) {
			fatal("can't create temporary file");
		}
	}
	mocp();
	term(0);	/* I */
}


