/*  This file is `NOT' GNU, scsi i/f library routines.

    Copyright (C) 1993-95  씎Y(oo) <HGG00736@niftyserve.or.jp>
*/
#ifdef	HAVE_CONFIG_H
#include	"config.h"
#endif
#include	"scsiif.h"

#define	invalidid(id)	(id&~7)
#define	adjbyte(param)	((param)=((param)>=0x100?0xff:(param)))
#define	adjword(param)	((param)=((param)>=0x10000?0xffff:(param)))
#define	blksizeok(size)	((0<=(size))&&((size)<=BLOCK_SIZE_LIMIT))


static	int	extmode = 0;	/* extend command disable:0, enable:!0 */

int	scsiif_debug = 0;
FILE*	scsiif_logfp = NULL;

char*	__scsi_stslist[] = {
/*0b0000*/	"good",
/*0b0001*/	"check condition",
/*0b0010*/	"condition met/good",
/*0b0011*/	"unknown status",
/*0b0100*/	"busy",
/*0b0101*/	"unknown status",
/*0b0110*/	"unknown status",
/*0b0111*/	"unknown status",
/*0b1000*/	"intermediate/good",
/*0b1001*/	"intermediate/check condition",
/*0b1010*/	"intermediate/condition met/good",
/*0b1011*/	"unknown status",
/*0b1100*/	"reservation conflict",
/*0b1101*/	"unknown status",
/*0b1110*/	"unknown status",
/*0b1111*/	"fail"
};


char*	__scsi_errlist[] = {
/*0x0*/	"no sence",
/*0x1*/	"recovered error",
/*0x2*/	"not ready",
/*0x3*/	"medium error",
/*0x4*/	"hardware error",
/*0x5*/	"illegal request",
/*0x6*/	"unit attension",
/*0x7*/	"data protect",
/*0x8*/	"blanck check",
/*0x9*/	"vendor unique",
/*0xa*/	"copy aborted",
/*0xb*/	"aborted command",
/*0xc*/	"equal",
/*0xd*/	"volume overflow",
/*0xe*/	"miscompare",
/*0xf*/	"reserved"
};


#ifdef	HUMAN68K

#define	SCSI_AVAILABLE()	(*((unsigned char*)0xed006f)==0x56)
#define	SCSI_BOARDID()		(*((unsigned char*)0xed0070)&7)
#define	SCSI_BOARDTYPE()	(*((unsigned char*)0xed0070)&8)
#define	BLOCK_SIZE_LIMIT	(2)

#ifdef	USE_LIBC68K
#include	<sys/scsi.h>
#include	<sys/dos.h>

#define	DOS_SUPER				_dos_super

#define	SCSI_CMDOUT(buf,n)		_scsi_cmdout((n),(const void*)(buf))
#define	SCSI_DATAIN(buf,n)		_scsi_datain((n),(void*)(buf))
#define	SCSI_DATAIN_P(buf,n)	_scsi_datain_p((n),(void*)(buf))
#define	SCSI_DATAOUT(buf,n)		_scsi_dataout((n),(void*)(buf))
#define	SCSI_DATAOUT_P(buf,n)	_scsi_dataout_p((n),(void*)(buf))
#define	SCSI_FORMAT(id,shift)	_scsi_format((shift),(id))
#define	SCSI_INQUIRY(id,buf,n)	_scsi_inquiry((n),(id),(struct _inquiry*)(buf))
#define	SCSI_MODESELECT(id,buf,n,mode)	_scsi_modeselect((mode),(n),(id),(const void*)(buf))
#define	SCSI_MODESENSE(id,buf,n,page)	_scsi_modesense((page),(n),(id),(void*)(buf))
#define	SCSI_MSGIN(buf)			_scsi_msgin((void*)(buf))
#define	SCSI_MSGOUT(buf)		_scsi_msgout((const void*)(buf))
#define	SCSI_PAMEDIUM(id,mode)	_scsi_pamedium((mode),(id))
#define	SCSI_PHASE()			_scsi_phase()
#define	SCSI_READ(id,buf,n,pos,blk)		_scsi_read((pos),(blk),(id),(n),(void*)(buf))
#define	SCSI_READCAP(id,buf)	_scsi_readcap((id),(struct _readcap*)(buf))
#define	SCSI_READEXT(id,buf,n,pos,blk)	_scsi_readext((pos),(blk),(id),(n),(void*)(buf))
#define	SCSI_REASSIGN(id,buf,n)	_scsi_reassign((n),(id),(const void*)(buf))
#define	SCSI_REQUEST(id,buf,n)	_scsi_request((n),(id),(void*)(buf))
#define	SCSI_RESET()			_scsi_reset()
#define	SCSI_REZEROUNIT(id)		_scsi_rezerounit(id)
#define	SCSI_SEEK(id,pos)		_scsi_seek((pos),(id))
#define	SCSI_SELECT(id)			_scsi_select(id)
#define	SCSI_STARTSTOP(id,mode)	_scsi_startstop((mode),(id))
#define	SCSI_STSIN(buf)			_scsi_stsin((void*)(buf))
#define	SCSI_TESTUNIT(id)		_scsi_testunit(id)
#define	SCSI_WRITE(id,buf,n,pos,blk)	_scsi_write((pos),(blk),(id),(n),(const void*)(buf))
#define	SCSI_WRITEEXT(id,buf,n,pos,blk)	_scsi_writeext((pos),(blk),(id),(n),(const void*)(buf))

#else	/*!USE_LIBC68K*/

#include	<doslib.h>
#include	<iocslib.h>

#define	DOS_SUPER				SUPER

#define	SCSI_CMDOUT(buf,n)		S_CMDOUT((n),(uchar*)(buf))
#define	SCSI_DATAIN(buf,n)		S_DATAIN((n),(uchar*)(buf))
#define	MISSING_SCSI_DATAIN_P	(1)
#define	SCSI_DATAOUT(buf,n)		S_DATAOUT((n),(uchar*)(buf))
#define	MISSING_SCSI_DATAOUT_P
#define	SCSI_FORMAT(id,shift)	S_FORMAT((shift),(id))
#define	SCSI_INQUIRY(id,buf,n)	S_INQUIRY((n),(id),(struct INQUIRY*)(buf))
#define	MISSING_SCSI_MODESELECT
#define	MISSING_SCSI_MODESENSE
#define	SCSI_MSGIN(buf)			S_MSGIN((uchar*)(buf))
#define	SCSI_MSGOUT(buf)		S_MSGOUT((uchar*)(buf))
#define	SCSI_PAMEDIUM(id,mode)	S_PAMEDIUM((mode),(id))
#define	SCSI_PHASE()			S_PHASE()
#define	SCSI_READ(id,buf,n,pos,blk)		S_READ((pos),(blk),(id),(n),(uchar*)(buf))
#define	SCSI_READCAP(id,buf)	S_READCAP((id),(struct READCAP*)(buf))
#define	SCSI_READEXT(id,buf,n,pos,blk)	S_READEXT((pos),(blk),(id),(n),(uchar*)(buf))
#define	SCSI_REASSIGN(id,buf,n)	S_REASSIGN((n),(id),(uchar*)(buf))
#define	SCSI_REQUEST(id,buf,n)	S_REQUEST((n),(id),(uchar*)(buf))
#define	SCSI_RESET()			S_RESET()
#define	SCSI_REZEROUNIT(id)		S_REZEROUNIT(id)
#define	SCSI_SEEK(id,pos)		S_SEEK((pos),(id))
#define	SCSI_SELECT(id)			S_SELECT(id)
#define	SCSI_STARTSTOP(id,mode)	S_STARTSTOP((mode),(id))
#define	SCSI_STSIN(buf)			S_STSIN((uchar*)(buf))
#define	SCSI_TESTUNIT(id)		S_TESTUNIT(id)
#define	SCSI_WRITE(id,buf,n,pos,blk)	S_WRITE((pos),(blk),(id),(n),(uchar*)(buf))
#define	SCSI_WRITEEXT(id,buf,n,pos,blk)	S_WRITEEXT((pos),(blk),(id),(n),(uchar*)(buf))

#endif	/*USE_LIBC68K*/

#endif	/*HUMAN68K*/

#ifdef	MSDOS
/*
 *	NOW PRINTING
 */
#endif


#define	SCSI_RPOS_MASK	(0x1fffffL)
#define	SCSI_RBLK_CNT	(0xf0)
#ifdef	MISSING_SCSI_READEXT
#define	SCSI_REPOS_MASK	(0x1fffffL)
#define	SCSI_REBLK_CNT	(0xf0)
#define	SCSI_READEXT	SCSI_READ
#else
#define	SCSI_REPOS_MASK	(0xffffffffL)
#define	SCSI_REBLK_CNT	(0xfff0)
#endif

#define	SCSI_WPOS_MASK	(0x1fffffL)
#define	SCSI_WBLK_CNT	(0xf0)
#ifdef	MISSING_SCSI_WRITEEXT
#define	SCSI_WEPOS_MASK	(0x1fffffL)
#define	SCSI_WEBLK_CNT	(0xf0)
#define	SCSI_WRITEEXT	SCSI_WRITE
#else
#define	SCSI_WEPOS_MASK	(0xffffffffL)
#define	SCSI_WEBLK_CNT	(0xfff0)
#endif

#ifndef	min
#define	min(a,b)	((a)<(b)?(a):(b))
#endif	/*min*/


#ifdef	HUMAN68K
/*
 *	SCSI I/F ֐gp\ׂ
 */
int	DEFUN_VOID(scsi_available)
{
	int	stack, status;

	stack = DOS_SUPER(0);
	status = SCSI_AVAILABLE();
	DOS_SUPER(stack);
	return status;
}


int	DEFUN_VOID(scsi_boardid)
{
	int	stack, id;

	stack = DOS_SUPER(0);
	id = SCSI_BOARDID();
	DOS_SUPER(stack);
	return id;
}


int	DEFUN_VOID(scsi_boardtype)
{
	int	stack, type;

	stack = DOS_SUPER(0);
	type = SCSI_BOARDTYPE();
	DOS_SUPER(stack);
	return type;
}
#endif	/*HUMAN68K*/


int	DEFUN(scsi_setextmode, (mode), int mode)
{
	int	ret;

	ret = extmode;
	extmode = mode;
	return ret;
}


int	DEFUN_VOID(scsi_getextmode)
{
	return extmode;
}


#ifdef	USE_LOWLEVEL_SCSI
/*
 *	SCSI id w肵Ȃ჌x SCSI I/F Cu
 */
int	DEFUN(scsi_cmdout, (buf, n), PTR buf AND int n)
{
#ifdef	MISSING_SCSI_CMDOUT
	return -1;
#else
	switch ((*(char*)buf>>5)&7) {
	case 0:	n =  6;	break;
	case 1:	n = 10;	break;
	case 5:	n = 12;	break;
	}
	return SCSI_CMDOUT(buf, n);
#endif
}


int	DEFUN(scsi_datain, (buf, n), PTR buf AND int n)
{
#ifdef	MISSING_SCSI_DATAIN
	return -1;
#else
	return SCSI_DATAIN(buf, n);
#endif
}


int	DEFUN(scsi_dataout, (buf, n), PTR buf AND int n)
{
#ifdef	MISSING_SCSI_DATAOUT
	return -1;
#else
	return SCSI_DATAOUT(buf, n);
#endif
}


int	DEFUN(scsi_msgin, (buf), PTR buf)
{
#ifdef	MISSING_SCSI_MSGIN
	return -1
#else
	return SCSI_MSGIN(buf);
#endif
}


int	DEFUN(scsi_msgout, (buf), PTR buf)
{
#ifdef	MISSING_SCSI_MSGOUT
	return -1
#else
	return SCSI_MSGOUT(buf);
#endif
}


int	DEFUN_VOID(scsi_phase)
{
#ifdef	MISSING_SCSI_PHASE
	return -1
#else
	return SCSI_PHASE();
#endif
}


void	DEFUN_VOID(scsi_reset)
{
	SCSI_RESET();
}


int	DEFUN(scsi_stsin, (buf), PTR buf)
{
#ifdef	MISSING_SCSI_STSIN
	return -1
#else
	return SCSI_STSIN(buf);
#endif
}
#endif	/*USE_LOWLEVEL_SCSI*/


/*
 *	SCSI id w肷 SCSI I/F Cu
 */
#ifdef	USE_SCSI_CAPACITY
int	DEFUN(scsi_capacity, (id, capp), int id AND capacity_s* capp)
{
	if (invalidid(id)) {
		return -1;
	}
	return SCSI_READCAP(id, capp);
}
#endif	/*USE_SCSI_CAPACITY*/


#ifdef	USE_SCSI_EJECT
int	DEFUN(scsi_eject, (id), int id)
{
	int	sts;
	char	buf[8];

	if (invalidid(id)) {
		return -1;
	}
	if ((sts = SCSI_TESTUNIT(id))
	||  (sts = scsi_inquiry(id, (inquiry_s*)buf, 4))
	||  ((buf[1]&0x80) == 0)	/* not removable medium */
	||  (sts = SCSI_PAMEDIUM(id, SCSI_EJECT_ENABLE))) {
		if (sts & SCSI_STS_CHKCOND) {
			scsi_request(id, buf, sizeof buf);
		}
		return -1;
	}
	return SCSI_STARTSTOP(id, SCSI_EJECT_MEDIUM);
}
#endif	/*USE_SCSI_EJECT*/


#ifdef	USE_SCSI_EJECTCNTL
int	DEFUN(scsi_ejectcntl, (id, mode), int id AND int mode)
{
	if (invalidid(id)) {
		return -1;
	}
	return SCSI_PAMEDIUM(id, mode);
}
#endif	/*USE_SCSI_EJECTCNTL*/


#ifdef	USE_SCSI_FORMAT
int	DEFUN(scsi_format, (id, shift), int id AND int shift)
{
	if (invalidid(id)) {
		return -1;
	}
	return SCSI_FORMAT(id, shift);
}
#endif	/*USE_SCSI_FORMAT*/


#ifdef	USE_SCSI_INQUIRY
int	DEFUN(scsi_inquiry, (id, inqp, n), int id AND inquiry_s* inqp AND int n)
{
	if (invalidid(id)) {
		return -1;
	}
	adjbyte(n);
	return SCSI_INQUIRY(id, inqp, n);
}
#endif	/*USE_SCSI_INQUIRY*/


#ifdef	USE_SCSI_MODESELECT
int	DEFUN(scsi_modeselect, (id, buf, n, mode),
		int id AND PTR buf AND int n AND int mode)
{
#ifdef	MISSING_SCSI_MODESELECT
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	adjbyte(n);
	return SCSI_MODESELECT(id, buf, n, mode);
#endif
}
#endif	/*USE_SCSI_MODESELECT*/


#ifdef	USE_SCSI_MODESENSE
int	DEFUN(scsi_modesense, (id, modp, n, page),
		int id AND modesense_s* modp AND int n AND int page)
{
#ifdef	MISSING_SCSI_MODESENSE
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	adjbyte(n);
	return SCSI_MODESENSE(id, modp, n, page);
#endif
}
#endif	/*USE_SCSI_MODESENSE*/


#ifdef	USE_SCSI_REASSIGN
int	DEFUN(scsi_reassign, (id, buf, n), int id AND CONST PTR buf AND int n)
{
#ifdef	MISSING_SCSI_REASSIGN
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	adjbyte(n);
	return SCSI_REASSIGN(id, buf, n);
#endif
}
#endif	/*USE_SCSI_REASSIGN*/


#ifdef	USE_SCSI_REQUEST
int	DEFUN(scsi_request, (id, buf, n), int id AND PTR buf AND int n)
{
#ifdef	MISSING_SCSI_REQUEST
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	adjbyte(n);
	return SCSI_REQUEST(id, buf, n);
#endif
}
#endif	/*USE_SCSI_REQUEST*/


#ifdef	USE_SCSI_REZEROUNIT
int	DEFUN(scsi_rezerounit, (id), int id)
{
#ifdef	MISSING_SCSI_REZEROUNIT
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	return SCSI_REZEROUNIT(id);
#endif
}
#endif	/*USE_SCSI_REZEROUNIT*/


#ifdef	USE_SCSI_SEEK
int	DEFUN(scsi_seek, (id, pos), int id AND long pos)
{
#ifdef	MISSING_SCSI_SEEK
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	return SCSI_SEEK(id, pos);
#endif
}
#endif	/*USE_SCSI_SEEK*/


#ifdef	USE_SCSI_SELECT
int	DEFUN(scsi_select, (id), int id)
{
#ifdef	MISSING_SCSI_SELECT
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	return SCSI_SELECT(id);
#endif
}
#endif	/*USE_SCSI_SELECT*/


#ifdef	USE_SCSI_STARTSTOP
int	DEFUN(scsi_startstop, (id, mode), int id AND int mode)
{
#ifdef	MISSING_SCSI_STARTSTOP
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	return SCSI_STARTSTOP(id, mode);
#endif
}
#endif	/*USE_SCSI_STARTSTOP*/


#ifdef	USE_SCSI_TESTUNIT
int	DEFUN(scsi_testunit, (id), int id)
{
#ifdef	MISSING_SCSI_TESTUNIT
	return -1;
#else
	if (invalidid(id)) {
		return -1;
	}
	return SCSI_TESTUNIT(id);
#endif
}
#endif	/*USE_SCSI_TESTUNIT*/


int	DEFUN(scsi_read, (id, buf, n, pos, blk),
	int id AND PTR buf AND int n AND long pos AND int blk)
{
	int	ret = 0;

	if (scsiif_debug && scsiif_logfp) {
		fprintf(scsiif_logfp, " scsi_read(%d, %p, %d, %06x, %06x)\n", id, buf, n, pos, blk);
	}
	if (invalidid(id) || !blksizeok(n)) {
		return -1;
	}
	if (extmode) {
		while (blk > 0) {
			if ((pos & ~SCSI_REPOS_MASK)
			||  (ret = SCSI_READEXT(id, buf, n, pos, min(blk, SCSI_REBLK_CNT))) < 0) {
				return -1;
			}
			pos += SCSI_REBLK_CNT;
			blk -= SCSI_REBLK_CNT;
			(char*)buf += (0x100L<<(long)n)*SCSI_REBLK_CNT;
		}
	}
	else {
		while (blk > 0) {
			if ((pos & ~SCSI_RPOS_MASK)
			||  (ret = SCSI_READ(id, buf, n, pos, min(blk, SCSI_RBLK_CNT))) < 0) {
				return -1;
			}
			pos += SCSI_RBLK_CNT;
			blk -= SCSI_RBLK_CNT;
			(char*)buf += (0x100L<<(long)n)*SCSI_RBLK_CNT;
		}
	}
	return ret;
}


int	DEFUN(scsi_write, (id, buf, n, pos, blk),
	int id AND CONST PTR buf AND int n AND long pos AND int blk)
{
	int	ret = 0;

	if (scsiif_debug && scsiif_logfp) {
		fprintf(scsiif_logfp, "scsi_write(%d, %p, %d, %06x, %06x)\n", id, buf, n, pos, blk);
	}
	if (invalidid(id) || !blksizeok(n)) {
		return -1;
	}
	if (extmode) {
		while (blk > 0) {
			if ((pos & ~SCSI_WEPOS_MASK)
			||  (ret = SCSI_WRITEEXT(id, buf, n, pos, min(blk, SCSI_WEBLK_CNT))) < 0) {
				return -1;
			}
			blk -= SCSI_WEBLK_CNT;
			pos += SCSI_WEBLK_CNT;
			(char*)buf += (0x100L<<(long)n)*SCSI_WEBLK_CNT;
		}
	}
	else {
		while (blk > 0) {
			if ((pos & ~SCSI_WPOS_MASK)
			||  (ret = SCSI_WRITE(id, buf, n, pos, min(blk, SCSI_WBLK_CNT))) < 0) {
				return -1;
			}
			blk -= SCSI_WBLK_CNT;
			pos += SCSI_WBLK_CNT;
			(char*)buf += (0x100L<<(long)n)*SCSI_WBLK_CNT;
		}
	}
	return ret;
}


/*FUNC
int	DEFUN(ck_scsi_testunit, (id), int id)
	id		eXg scsi unit id
߂	scsi unit  ready Ȃ 0
		łȂȂ΁A 8bit  scsi sts,  8bit sence key

@\	scsi unit  ready `FbN
ENDFUNC*/
int	DEFUN(ck_scsi_testunit, (id), int id)
{
	int	sts;
	char	buf[8];

	if ((sts = scsi_testunit(id)) & SCSI_STS_CHKCOND) {
		/*
		 *	check condition ̓G[Xe[^XKv
		 */
		scsi_request(id, buf, sizeof buf);
		sts |= (buf[2]&0xf)<<8;		/* sense key ݒ */
	}
	return sts;
}


/*FUNC
int	DEFUN(ck_scsi_removable, (id), int id)
	id		removable eXg scsi unit id
߂	scsi unit  removable Ȃ 1
		scsi unit  removable łȂȂ 0
		G[ɂ͉ 8bit  scsi sts,  8bit sence key

@\	removable medium ̌
ENDFUNC*/
int	DEFUN(ck_scsi_removable, (id), int id)
{
	int	sts;
	char	buf[8];

	if ((sts = scsi_inquiry(id, (inquiry_s*)buf, 4)) & SCSI_STS_CHKCOND) {
		/*
		 *	check condition ̓G[Xe[^XKv
		 */
		scsi_request(id, buf, sizeof buf);
		sts |= (buf[2]&0xf)<<8;		/* sense key ݒ */
	}
	else {
		sts = ((buf[1] & 0x80) ? 1 : 0);
	}
	return sts;
}


/*FUNC
int	DEFUN(ck_scsi_capacity, (id, capp), int id AND capacity_s* capp)
	id		capacity 擾 scsi unit id
߂	펞 0
		G[ɂ͉ 8bit  scsi sts,  8bit sence key

@\	check condition tLpVeB擾
ENDFUNC*/
int	DEFUN(ck_scsi_capacity, (id, capp), int id AND capacity_s* capp)
{
	int	sts;
	char	buf[8];

	if ((sts = scsi_capacity(id, capp)) & SCSI_STS_CHKCOND) {
		/*
		 *	check condition ̓G[Xe[^XKv
		 */
		scsi_request(id, buf, sizeof buf);
		sts |= (buf[2]&0xf)<<8;		/* sense key ݒ */
	}
	return sts;
}


/*FUNC
int	DEFUN(ck_scsi_wrtprotect, (id), int id)
	id		݋֎~ scsi unit id
߂	write protect:1, no write protect:0
		G[ɂ͉ 8bit  scsi sts,  8bit sence key

@\	check condition t݋֎~fBA
ENDFUNC*/
int	DEFUN(ck_scsi_wrtprotect, (id), int id)
{
	int	sts;
	char	buf[8];

	if ((sts = scsi_modesense(id, (modesense_s*)buf, sizeof buf, 0)) & SCSI_STS_CHKCOND) {
		/*
		 *	check condition ̓G[Xe[^XKv
		 */
		scsi_request(id, buf, sizeof buf);
		sts |= (buf[2]&0xf)<<8;		/* sense key ݒ */
	}
	else {
		sts = ((buf[2] & 0x80) ? 1 : 0);
	}
	return sts;
}


/*FUNC
int	DEFUN(ck_scsi_ejectcntl, (id, mode), int id AND int mode)
	id		CWFNgRg[ݒ肷 scsi id
		mode	eject enable:0, disable:1
߂	펞 0
		G[ɂ͉ 8bit  scsi sts,  8bit sence key

@\	check condition tCWFNg
ENDFUNC*/
int	DEFUN(ck_scsi_ejectcntl, (id, mode), int id AND int mode)
{
	int	sts;
	char	buf[8];

	if ((sts = scsi_ejectcntl(id, mode)) & SCSI_STS_CHKCOND) {
		/*
		 *	check condition ̓G[Xe[^XKv
		 */
		scsi_request(id, buf, sizeof buf);
		sts |= (buf[2]&0xf)<<8;		/* sense key ݒ */
	}
	return sts;
}


#ifdef	DEBUG
#include	<stdio.h>
#include	<ctype.h>
#ifdef	__STDC__
#include	<stdlib.h>
#endif

static char	buf[255];

void	DEFUN_VOID(main)
{
	int i, id, myid, sts;
	char* p;
	inquiry_s* inqp;

	if (!scsi_available()) {
		printf("scsi driver is not available\n");
		exit(1);
	}
	myid = scsi_boardid();
	for (id = 0; id < 8; id++) {
		if (id == myid) {
			printf("scsi id=%d is %sernal board\n", id, (scsi_boardtype()?"ext":"int"));
			continue;
		}
		printf("scsi id=%d, status=", id);
		sts = scsi_testunit(id);
		printf("%s\n", scsi_stslist(sts));
		if (sts == -1) continue;

		if (scsi_inquiry(id, (inquiry_s*)buf, sizeof buf) != -1) {
			inqp = (inquiry_s*)buf;
			printf("\ttype=%02x, rmb=%s, ver=%02x, len=%d  ",
				inqp->type, (inqp->rmb&0x80 ? "yes" : "no "), inqp->ver, inqp->len);
			p = (char*)inqp->buf;
			for (i = inqp->len; i > 0; i--) {
				if (isprint(*p)) {
					putchar(*p);
				}
				p++;
			}
			putchar('\n');
		}
		if ((sts = scsi_capacity(id, (capacity_s*)buf)) != -1) {
			/*
			 *	CAUTION: these code for MSB first machine only!
			 */
			if (!sts) {
				printf("\tblock capacity=%08lx(%ld), block size=%08lx(%ld)\n",
					*(long*)(buf+0), *(long*)(buf+0), *(long*)(buf+4), *(long*)(buf+4));
			}
		}
		if (scsi_modesense(id, (modesense_s*)buf, sizeof buf, 0) != -1) {
			if (buf[0]) {
				printf("\tmode sence data length=%d, desc length=%d\n", buf[0], buf[3]);
				/*
				 *	CAUTION: these code for MSB first machine only!
				 */
				for (i = 0; buf[3] > 0; i++) {
					printf("\t\tblock number=%06lx(%ld), block length=%06lx(%ld)\n",
						*(long*)(buf+4+i*8)&0xffffff, *(long*)(buf+4+i*8)&0xffffff,
						*(long*)(buf+8+i*8)&0xffffff, *(long*)(buf+8+i*8)&0xffffff);
					buf[3] -= 8;
				}
			}
		}
		/*
		scsi_eject(id);
		*/
	}
	exit(0);
}
#endif
