/*  This file is `NOT' GNU, scsi i/f library header.

    Copyright (C) 1993-95  씎Y(oo) <HGG00736@niftyserve.or.jp>
*/
#ifndef	_SCSIIF_H_
#define	_SCSIIF_H_	(1)

#include	<stdio.h>
#include	"ansidecl.h"

#ifndef	uchar
#define	uchar	unsigned char
#endif

#define	SCSI_STS_MASK		(0x1e)
#define	SCSI_STS_CHKCOND	(0x02)
#define	SCSI_STS_CONDMET	(0x04)
#define	SCSI_STS_BUSY		(0x08)
#define	SCSI_STS_INGOOD		(0x10)
#define	SCSI_STS_INCNDMET	(0x14)
#define	SCSI_STS_CONFLICT	(0x18)

#define	SCSI_EJECT_ENABLE	(0)
#define	SCSI_EJECT_DISABLE	(1)

#define	SCSI_STOP_UNIT		(0)
#define	SCSI_START_UNIT		(1)
#define	SCSI_EJECT_MEDIUM	(2)

typedef	struct	{
	uchar	density;	/* dencity code, if HD then 0x00 */
	uchar	block[3];	/* MSB first */
	uchar	reserved;
	uchar	blksiz[3];	/* MSB first */
}	blkdesc_s;

typedef	struct	{
	uchar	block[4];	/* MSB first */
	uchar	blksiz[4];	/* MSB first */
}	capacity_s;

typedef	struct	{
	uchar	length;		/* sence data length without itself */
	uchar	type;		/* medium type */
	uchar	wp;			/* write protect:bit7 */
	uchar	desclen;	/* block descriptor length */
	blkdesc_s	desc[0];
}	modesense_s;


typedef	struct	{
	uchar	type;	/* device type*/
	uchar	rmb;	/* if removable media then bit7==1 */
	uchar	ver;	/* ISO/ECMA/ANSI version */
	uchar	res;	/* reserved */
	uchar	len;	/* additional length */
	uchar	buf[0];	/* buf[0~2]:vender uniq, buf[3~10]:vender id, buf[11~26]:product id, buf[27~30]:farm rev */
}	inquiry_s;

#define	INQUIRYTYPE_DAD	(0x00)	/* Direct Access Device */
#define	INQUIRYTYPE_SAD	(0x01)	/* Sequential Access Device */
#define	INQUIRYTYPE_PRN	(0x02)	/* PRiNter device */
#define	INQUIRYTYPE_PRC	(0x03)	/* PRoCcesor device */
#define	INQUIRYTYPE_WRM	(0x03)	/* WoRM device */
#define	INQUIRYTYPE_ROD	(0x03)	/* Read Only direct device */


#ifdef	HUMAN68K
extern int	EXFUN(scsi_available, (void));
extern int	EXFUN(scsi_boardid, (void));
extern int	EXFUN(scsi_boardtype, (void));
#endif	/*HUMAN68K*/

extern int	scsiif_debug;
extern FILE*scsiif_logfp;

extern int	EXFUN(scsi_setextmode, (int mode));
extern int	EXFUN(scsi_getextmode, (void));

/*
 *	scsi i/f low level library
 */
extern int	EXFUN(scsi_cmdout, (PTR buf, int n));
extern int	EXFUN(scsi_datain, (PTR buf, int n));
extern int	EXFUN(scsi_dataout, (PTR buf, int n));
extern int	EXFUN(scsi_msgin, (PTR buf));
extern int	EXFUN(scsi_msgout, (PTR buf));
extern int	EXFUN(scsi_phase, (void));
extern void	EXFUN(scsi_reset, (void));
extern int	EXFUN(scsi_stsin, (PTR buf));

/*
 *	scsi i/f high level library
 */
extern int	EXFUN(scsi_capacity, (int id, capacity_s* capp));
extern int	EXFUN(scsi_eject, (int id));
extern int	EXFUN(scsi_ejectcntl, (int id, int mode));
extern int	EXFUN(scsi_format, (int id, int shift));
extern int	EXFUN(scsi_inquiry, (int id, inquiry_s* inqp, int n));
extern int	EXFUN(scsi_modeselect, (int id, PTR buf, int n, int mode));
extern int	EXFUN(scsi_modesense, (int id, modesense_s* modp, int n, int page));
extern int	EXFUN(scsi_reassign, (int id, CONST PTR buf, int n));
extern int	EXFUN(scsi_request, (int id, PTR buf, int n));
extern int	EXFUN(scsi_rezerounit, (int id));
extern int	EXFUN(scsi_seek, (int id, long pos));
extern int	EXFUN(scsi_select, (int id));
extern int	EXFUN(scsi_startstop, (int id, int mode));
extern int	EXFUN(scsi_testunit, (int id));

extern int	EXFUN(scsi_read, (int id, PTR buf, int n, long pos, int blk));
extern int	EXFUN(scsi_write, (int id, CONST PTR buf, int n, long pos, int blk));

/*
 *	scsi status/error support
 */
extern	char*	__scsi_stslist[];
extern	char*	__scsi_errlist[];

#define	scsi_stslist(code)	__scsi_stslist[((code)>>1)&0xf]
#define	scsi_errlist(code)	__scsi_errlist[(code)&0xf]

/*
 *	check condition ɑ΂ scsi_request() s library
 */
extern int	EXFUN(ck_scsi_testunit, (int id));
extern int	EXFUN(ck_scsi_removable, (int id));
extern int	EXFUN(ck_scsi_capacity, (int id, capacity_s* capp));
extern int	EXFUN(ck_scsi_wrtprotect, (int id));
extern int	EXFUN(ck_scsi_ejectcntl, (int id, int mode));

#endif	/*_SCSIIF_H_*/
